import os
import sys
import XPILib


#########################
# Start Main program    #
#########################
if __name__ == "__main__":
    pgm_name = sys.argv[0]
    # Check system argument and get data directory
    if len(sys.argv) < 2:
        XPILib.UserMessageXPIPeak("Requires one command arguments")
    data_directory = sys.argv[1]

    # Parse XPIPeak config file
    peak_config_path = os.path.join(data_directory, XPILib.file_peak_config)
    peak_config_obj = XPILib.XPIPeakConfig(peak_config_path)
    print(XPILib.pgm_info)

    # Parse xpiviz_config file
    if len(sys.argv) == 3:
        file_config_viz = sys.argv[2]
    else:
        file_config_viz = os.path.join(data_directory, XPILib.file_viz_config)
    XPILib.check_file(file_config_viz)
    config_XPIViz = XPILib.XPIVizConfig(file_config_viz)

    # Parse XPI_output_time.txt to get path of XPIQuant_config.txt
    file_config_quant = XPILib.find_data_directory_from_time_file(data_directory)

    # Parse xpiquant_config file
    config_quant_obj = XPILib.XPIQuantConfig(file_config_quant)

    # Parse XPI_output_all.txt
    file_xpi_output_all = os.path.join(data_directory, XPILib.file_all)
    xpi_all_obj = XPILib.XPIOutAll(file_xpi_output_all, config_XPIViz)

    XPILib.process_peak_detection(data_directory, xpi_all_obj, peak_config_obj, config_quant_obj, config_XPIViz)
